searchNodes=[{"doc":"A toolkit for fuzzy logic, this library includes functions for creating fuzzy variables, sets, rules and a FLS.","ref":"Flex.html","title":"Flex","type":"module"},{"doc":"","ref":"Flex.EngineAdapter.html","title":"Flex.EngineAdapter","type":"behaviour"},{"doc":"","ref":"Flex.EngineAdapter.html#default_fuzzification/3","title":"Flex.EngineAdapter.default_fuzzification/3","type":"function"},{"doc":"","ref":"Flex.EngineAdapter.html#defuzzification/1","title":"Flex.EngineAdapter.defuzzification/1","type":"function"},{"doc":"","ref":"Flex.EngineAdapter.html#c:defuzzification/1","title":"Flex.EngineAdapter.defuzzification/1","type":"callback"},{"doc":"","ref":"Flex.EngineAdapter.html#fuzzification/2","title":"Flex.EngineAdapter.fuzzification/2","type":"function"},{"doc":"","ref":"Flex.EngineAdapter.html#c:fuzzification/2","title":"Flex.EngineAdapter.fuzzification/2","type":"callback"},{"doc":"","ref":"Flex.EngineAdapter.html#get_crisp_output/1","title":"Flex.EngineAdapter.get_crisp_output/1","type":"function"},{"doc":"","ref":"Flex.EngineAdapter.html#inference/3","title":"Flex.EngineAdapter.inference/3","type":"function"},{"doc":"","ref":"Flex.EngineAdapter.html#c:inference/3","title":"Flex.EngineAdapter.inference/3","type":"callback"},{"doc":"","ref":"Flex.EngineAdapter.html#validation/4","title":"Flex.EngineAdapter.validation/4","type":"function"},{"doc":"","ref":"Flex.EngineAdapter.html#c:validation/4","title":"Flex.EngineAdapter.validation/4","type":"callback"},{"doc":"","ref":"Flex.EngineAdapter.html#t:antecedent/0","title":"Flex.EngineAdapter.antecedent/0","type":"type"},{"doc":"","ref":"Flex.EngineAdapter.html#t:consequent/0","title":"Flex.EngineAdapter.consequent/0","type":"type"},{"doc":"Engine Adapter State. :type - defines the inference engine behavior (default: Mamdini). :fuzzy_antecedent - fuzzification output. :fuzzy_consequent - inference output. :crisp_output - defuzzification output.","ref":"Flex.EngineAdapter.html#t:engine_state/0","title":"Flex.EngineAdapter.engine_state/0","type":"type"},{"doc":"","ref":"Flex.EngineAdapter.html#t:rules/0","title":"Flex.EngineAdapter.rules/0","type":"type"},{"doc":"An adaptive network-based fuzzy inference system (ANFIS) is a kind of artificial neural network that is based on Takagi–Sugeno fuzzy inference system, this implementation use backpropagation, only Gaussian Membership function are allowed. Reference: https://upcommons.upc.edu/bitstream/handle/2099.1/20296/Annex%201%20-%20Introduction%20to%20Adaptive%20Neuro-Fuzzy%20Inference%20Systems%20%28ANFIS%29.pdf Jang, J-SR. &quot;ANFIS: adaptive-network-based fuzzy inference system.&quot; IEEE transactions on systems, man, and cybernetics 23.3 (1993): 665-685.","ref":"Flex.EngineAdapter.ANFIS.html","title":"Flex.EngineAdapter.ANFIS","type":"module"},{"doc":"","ref":"Flex.EngineAdapter.ANFIS.html#backward_pass/3","title":"Flex.EngineAdapter.ANFIS.backward_pass/3","type":"function"},{"doc":"","ref":"Flex.EngineAdapter.ANFIS.html#forward_pass/3","title":"Flex.EngineAdapter.ANFIS.forward_pass/3","type":"function"},{"doc":"","ref":"Flex.EngineAdapter.ANFIS.html#inference_engine/3","title":"Flex.EngineAdapter.ANFIS.inference_engine/3","type":"function"},{"doc":"","ref":"Flex.EngineAdapter.ANFIS.html#least_square_estimate/4","title":"Flex.EngineAdapter.ANFIS.least_square_estimate/4","type":"function"},{"doc":"","ref":"Flex.EngineAdapter.ANFIS.html#weighted_average_method/1","title":"Flex.EngineAdapter.ANFIS.weighted_average_method/1","type":"function"},{"doc":"Mamdani fuzzy inference was first introduced as a method to create a control system by synthesizing a set of linguistic control rules obtained from experienced human operators. In a Mamdani system, the output of each rule is a fuzzy set. Since Mamdani systems have more intuitive and easier to understand rule bases, they are well-suited to expert system applications where the rules are created from human expert knowledge, such as medical diagnostics.","ref":"Flex.EngineAdapter.Mamdani.html","title":"Flex.EngineAdapter.Mamdani","type":"module"},{"doc":"Turns an consequent fuzzy variable (output) from a fuzzy value to a crisp value (centroid method).","ref":"Flex.EngineAdapter.Mamdani.html#centroid_method/1","title":"Flex.EngineAdapter.Mamdani.centroid_method/1","type":"function"},{"doc":"","ref":"Flex.EngineAdapter.Mamdani.html#inference_engine/3","title":"Flex.EngineAdapter.Mamdani.inference_engine/3","type":"function"},{"doc":"Takagi-Sugeno-Kang fuzzy inference uses singleton output membership functions that are either constant or a linear function of the input values. The defuzzification process for a Sugeno system is more computationally efficient compared to that of a Mamdani system, since it uses a weighted average or weighted sum of a few data points rather than compute a centroid of a two-dimensional area.","ref":"Flex.EngineAdapter.TakagiSugeno.html","title":"Flex.EngineAdapter.TakagiSugeno","type":"module"},{"doc":"","ref":"Flex.EngineAdapter.TakagiSugeno.html#inference_engine/3","title":"Flex.EngineAdapter.TakagiSugeno.inference_engine/3","type":"function"},{"doc":"Turns an consequent fuzzy variable (output) from a fuzzy value to a crisp value (weighted average method).","ref":"Flex.EngineAdapter.TakagiSugeno.html#weighted_average_method/1","title":"Flex.EngineAdapter.TakagiSugeno.weighted_average_method/1","type":"function"},{"doc":"An interface to create Membership Functions reference.","ref":"Flex.MembershipFun.html","title":"Flex.MembershipFun","type":"module"},{"doc":"Gaussian membership derivatived function. m - (number) Mean, s - (number) Standard deviation, it must not be equal to 0. f - (number) Fuzzification Factor. mu - (number) Last membership function value.","ref":"Flex.MembershipFun.html#d_gaussian/4","title":"Flex.MembershipFun.d_gaussian/4","type":"function"},{"doc":"Generalized Bell membership derivatived function. c - (number) Center. s - (number) Slope. b - (number) The width of the curve, it must not be equal to 0. Definition of Generalized Bell function is: y ( x ) = 1 / ( 1 + | ( ( x - c ) / b ) | ^ ( 2 * s ) )","ref":"Flex.MembershipFun.html#d_gbell/4","title":"Flex.MembershipFun.d_gbell/4","type":"function"},{"doc":"An interface to execute derivatives of membership functions, where, z_i - is the i'th rule output. x, y - are the values of input 1 and input 2, respectively. a_i, b_i, and c_i - are constant coefficients of the i'th rule output. For a zero-order Takagi-Sugeno system, z_i is a constant (a = b = 0).","ref":"Flex.MembershipFun.html#derivative/4","title":"Flex.MembershipFun.derivative/4","type":"function"},{"doc":"Gaussian membership function. m - (number) Mean, s - (number) Standard deviation, it must not be equal to 0. f - (number) Fuzzification Factor,","ref":"Flex.MembershipFun.html#gaussian/1","title":"Flex.MembershipFun.gaussian/1","type":"function"},{"doc":"Generalized Bell membership function. c - (number) Center. s - (number) Slope. b - (number) The width of the curve, it must not be equal to 0. Definition of Generalized Bell function is: y ( x ) = 1 / ( 1 + | ( ( x - c ) / b ) | ^ ( 2 * s ) )","ref":"Flex.MembershipFun.html#gbell/1","title":"Flex.MembershipFun.gbell/1","type":"function"},{"doc":"For Takagi-Sugeno-Kang fuzzy inference, uses this output membership functions that are either constant or a linear function that will be combined with the input values. Example (2 inputs 1 output): z_i = a_i x + b_i y + c_i where, z_i - is the i'th rule output. x, y - are the values of input 1 and input 2, respectively. a_i, b_i, and c_i - are constant coefficients of the i'th rule output. For a zero-order Takagi-Sugeno system, z_i is a constant (a = b = 0). ## Example (in Elixir) iex&gt; { z_i_mf , nil } = MembershipFun . linear_combination ( [ a_i , b_i , c_i ] ) iex&gt; z_i = z_i_mf . ( [ x , y ] )","ref":"Flex.MembershipFun.html#linear_combination/1","title":"Flex.MembershipFun.linear_combination/1","type":"function"},{"doc":"Pi-shaped membership function.","ref":"Flex.MembershipFun.html#pi_shaped/1","title":"Flex.MembershipFun.pi_shaped/1","type":"function"},{"doc":"S-shaped membership function.","ref":"Flex.MembershipFun.html#s_shaped/1","title":"Flex.MembershipFun.s_shaped/1","type":"function"},{"doc":"Saturation membership function.","ref":"Flex.MembershipFun.html#saturation/1","title":"Flex.MembershipFun.saturation/1","type":"function"},{"doc":"Shoulder membership function.","ref":"Flex.MembershipFun.html#shoulder/1","title":"Flex.MembershipFun.shoulder/1","type":"function"},{"doc":"Sigmoidal membership function. c - (number) Crossover point. s - (number) Slope. Definition of Generalized Bell function is: y ( x ) = 1 / ( 1 + e ^ ( - s ( x - c ) ) )","ref":"Flex.MembershipFun.html#sigmoid/1","title":"Flex.MembershipFun.sigmoid/1","type":"function"},{"doc":"Trapezoidal membership function.","ref":"Flex.MembershipFun.html#trapezoidal/1","title":"Flex.MembershipFun.trapezoidal/1","type":"function"},{"doc":"Triangle membership function.","ref":"Flex.MembershipFun.html#triangle/1","title":"Flex.MembershipFun.triangle/1","type":"function"},{"doc":"Z-shaped membership function.","ref":"Flex.MembershipFun.html#z_shaped/1","title":"Flex.MembershipFun.z_shaped/1","type":"function"},{"doc":"An interface to create Linguistic Rules.","ref":"Flex.Rule.html","title":"Flex.Rule","type":"module"},{"doc":"Fuzzy AND operator.","ref":"Flex.Rule.html#&&&/2","title":"Flex.Rule.&&&/2","type":"function"},{"doc":"Fuzzy THEN operator.","ref":"Flex.Rule.html#%3E%3E%3E/2","title":"Flex.Rule.>>>/2","type":"function"},{"doc":"Gets the arguments of the Fuzzy Rule","ref":"Flex.Rule.html#get_rule_parameters/3","title":"Flex.Rule.get_rule_parameters/3","type":"function"},{"doc":"Creates a Linguistic Rule. The following options are require: :statement - Defines the rule behavior. :antecedent - (list) Defines the input variables. :consequent - Defines the output variable.","ref":"Flex.Rule.html#new/1","title":"Flex.Rule.new/1","type":"function"},{"doc":"Fuzzy Rules AST (Tuple).","ref":"Flex.Rule.html#statement/2","title":"Flex.Rule.statement/2","type":"function"},{"doc":"Fuzzy AND operator (product).","ref":"Flex.Rule.html#tau/2","title":"Flex.Rule.tau/2","type":"function"},{"doc":"Fuzzy OR operator.","ref":"Flex.Rule.html#%7C%7C%7C/2","title":"Flex.Rule.|||/2","type":"function"},{"doc":"Fuzzy IS operator.","ref":"Flex.Rule.html#~%3E/2","title":"Flex.Rule.~>/2","type":"function"},{"doc":"Linguistic Rule struct. :statement - Rules behavior. :antecedent - (list) Input variables. :consequent - Output variable.","ref":"Flex.Rule.html#t:t/0","title":"Flex.Rule.t/0","type":"type"},{"doc":"An interface to create Fuzzy Sets struct.","ref":"Flex.Set.html","title":"Flex.Set","type":"module"},{"doc":"Creates a Fuzzy set. The following options are require: :mf_type - (string) Defines which type of membership function uses the set (e.g., &quot;triangle&quot;). :tag - (string) defines the linguistic name of the fuzzy set (e.g., &quot;too hot&quot;), :mf_params - The parameters of the membership function, see Membership functions.","ref":"Flex.Set.html#new/1","title":"Flex.Set.new/1","type":"function"},{"doc":"Updates a Fuzzy set with new membership function parameters.","ref":"Flex.Set.html#update/2","title":"Flex.Set.update/2","type":"function"},{"doc":"Updates a Fuzzy set depending on the gradient.","ref":"Flex.Set.html#update/3","title":"Flex.Set.update/3","type":"function"},{"doc":"Fuzzy Set struct. :mf_type - Defines which type of membership function uses the set. :mf - Anonymous function reference of the membership function. :mf_center - The center point of the membership function. :mf_params - The parameters of the membership function. :tag - Linguistic name of the fuzzy set.","ref":"Flex.Set.html#t:t/0","title":"Flex.Set.t/0","type":"type"},{"doc":"An interface to create a Fuzzy Logic Control System (FLS). The Fuzzy controllers are very simple conceptually. They consist of an input stage (fuzzification), a processing stage (inference), and an output stage (defuzzification).","ref":"Flex.System.html","title":"Flex.System","type":"module"},{"doc":"Adjust the premise free parameters of the FIS (only avaliable with ANFIS engine), using the following methods: Learning method: Steepest gradient Backpropagation. Energy function: 0.5 * (target - output)^2","ref":"Flex.System.html#backward_pass/2","title":"Flex.System.backward_pass/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Flex.System.html#child_spec/1","title":"Flex.System.child_spec/1","type":"function"},{"doc":"Computes the Fuzzy Logic System output for a given input vector.","ref":"Flex.System.html#compute/2","title":"Flex.System.compute/2","type":"function"},{"doc":"Adjust the consequent free parameters of the FIS (only avaliable with ANFIS engine), using the following methods: Learning method: Steepest gradient Backpropagation. Energy function: 0.5 * (target - output)^2","ref":"Flex.System.html#forward_pass/2","title":"Flex.System.forward_pass/2","type":"function"},{"doc":"Gets the current system state.","ref":"Flex.System.html#get_state/1","title":"Flex.System.get_state/1","type":"function"},{"doc":"Adjust the free parameters of the FIS (only avaliable with ANFIS engine), using the following methods: Forward method: Least Square Estimate. Learning method: Steepest gradient Backpropagation. Energy function: 0.5 * (target - output)^2 Note: this functions fires both forward and backward passes with a batch of data.","ref":"Flex.System.html#hybrid_offline_learning/4","title":"Flex.System.hybrid_offline_learning/4","type":"function"},{"doc":"Adjust the free parameters of the FIS (only avaliable with ANFIS engine), using the following methods: Learning method: Steepest gradient Backpropagation. Energy function: 0.5 * (target - output)^2 Note: this functions fires both forward and backward passes.","ref":"Flex.System.html#hybrid_online_learning/2","title":"Flex.System.hybrid_online_learning/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Flex.System.html#init/1","title":"Flex.System.init/1","type":"function"},{"doc":"Sets the Inference Engine type.","ref":"Flex.System.html#set_engine_type/2","title":"Flex.System.set_engine_type/2","type":"function"},{"doc":"Sets the Learning rate (etha).","ref":"Flex.System.html#set_learning_rate/2","title":"Flex.System.set_learning_rate/2","type":"function"},{"doc":"Spawns a Fuzzy Logic System. The following options are require: :rules - Defines the behavior of the system based on a list of rules. :antecedent - (list) Defines the input variables. :consequent - Defines the output variable.","ref":"Flex.System.html#start_link/2","title":"Flex.System.start_link/2","type":"function"},{"doc":"","ref":"Flex.System.html#stop/1","title":"Flex.System.stop/1","type":"function"},{"doc":"Fuzzy Logic System state. :rules - (list) A list of rules that defines the behavior of the Fuzzy logic systems. :consequent - Output variable. :antecedent - a list of the input variables. :engine_type - defines the inference engine behavior (default: Mamdini). :sets_in_rules - list of sets involve in the rules (optional, required by ANFIS). :learning_rate - is the speed at which the system parameters are adjusted (ANFIS only). :initial_gamma - is the speed at which the system parameters are adjusted (LSE, ANFIS only).","ref":"Flex.System.html#t:t/0","title":"Flex.System.t/0","type":"type"},{"doc":"Module with helper functions.","ref":"Flex.Util.html","title":"Flex.Util","type":"module"},{"doc":"An interface to create Fuzzy Variables.","ref":"Flex.Variable.html","title":"Flex.Variable","type":"module"},{"doc":"Turns an antecedent fuzzy variable (input) from a crisp value to a fuzzy value.","ref":"Flex.Variable.html#fuzzification/2","title":"Flex.Variable.fuzzification/2","type":"function"},{"doc":"Creates a Fuzzy Variable. The following options are require: :tag - (string) Defines the linguistic name of the fuzzy variable (e.g., &quot;error&quot;), :fuzzy_sets - (list) Defines which type of membership function use the set (e.g., &quot;triangle&quot;). :type - (atom) Defines the type of variable (e.g., :antecedent or :consequent), :range - (range) The range in which the variable exists.","ref":"Flex.Variable.html#new/1","title":"Flex.Variable.new/1","type":"function"},{"doc":"Updates a consequent Fuzzy Variable (ANFIS).","ref":"Flex.Variable.html#update/2","title":"Flex.Variable.update/2","type":"function"},{"doc":"Updates an antecedent Fuzzy Variable (ANFIS).","ref":"Flex.Variable.html#update/3","title":"Flex.Variable.update/3","type":"function"},{"doc":"Fuzzy Variable struct. :tag - (string) Defines the linguistic name of the fuzzy variable (e.g., &quot;error&quot;). :fuzzy_sets - (list) Defines which all the fuzzy sets related to the variable. :mf_values - (map) The current values of each of the membership functions of the fuzzy sets. :range - (range) The range in which the variable exists. :type - (atom) :antecedent if the variable is an input or consequent for outputs.","ref":"Flex.Variable.html#t:t/0","title":"Flex.Variable.t/0","type":"type"},{"doc":"FLex A toolkit for fuzzy logic, this library includes functions to make fuzzy sets, variables and rules for creating a Fuzzy Logic System (FLS). The goal of FLex is to easily design and efficiently operate fuzzy logic controllers without relying on external libraries.","ref":"readme.html","title":"README","type":"extras"},{"doc":"Features Installation Usage Sets Variables Rules System ANFIS Documentation Contributing License TODO","ref":"readme.html#index","title":"README - Index","type":"extras"},{"doc":"The following list is the current supported backend for each component of the FLS: Linguistic Rules: Lambda function syntax Tuple syntax Membership functions: Triangular Trapezoidal Saturation Shoulder Gauss Generalized Bell Sigmoid Z-shaped S-shaped Pi-shaped Linear Combination (Takagi-Sugeno, ANFIS only) Fuzzy Inference Systems: Mamdani: Inference: Min Output Combination: Root-sum-square Defuzzification: Centroid Takagi-Sugeno: Inference: Max Product Defuzzification: Weighted average ANFIS: Inference: Max Product Defuzzification: Weighted average Optimization Method: Backpropagation. Hybrid (Backpropagation, LSE). NOTE: All systems are single output.","ref":"readme.html#features","title":"README - Features","type":"extras"},{"doc":"The package can be installed by adding flex to your list of dependencies in mix.exs : def deps do [ { :flex , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Sets Step 1: Define all fuzzy sets with Flex.Set.new/1 , the following options are require: mf_type - (string) Defines which type of membership function uses the set (e.g., &quot;triangle&quot;). tag - (string) defines the linguistic name of the fuzzy set (e.g., &quot;too hot&quot;), mf_params - The parameters of the membership function, see Membership functions. t_h = Flex.Set . new ( tag : &quot;too hot&quot; , mf_type : &quot;saturation&quot; , mf_params : [ - 2 , 0 , - 4 ] ) j_r = Flex.Set . new ( tag : &quot;just right&quot; , mf_type : &quot;triangle&quot; , mf_params : [ - 2 , 0 , 2 ] ) t_c = Flex.Set . new ( tag : &quot;too cold&quot; , mf_type : &quot;shoulder&quot; , mf_params : [ 0 , 2 , 4 ] ) g_h = Flex.Set . new ( tag : &quot;getting hotter&quot; , mf_type : &quot;saturation&quot; , mf_params : [ - 5 , 0 , - 10 ] ) n_c = Flex.Set . new ( tag : &quot;no change&quot; , mf_type : &quot;triangle&quot; , mf_params : [ - 5 , 0 , 5 ] ) g_c = Flex.Set . new ( tag : &quot;getting colder&quot; , mf_type : &quot;shoulder&quot; , mf_params : [ 0 , 5 , 10 ] ) co = Flex.Set . new ( tag : &quot;cool&quot; , mf_type : &quot;saturation&quot; , mf_params : [ - 50 , 0 , - 100 ] ) d_n = Flex.Set . new ( tag : &quot;do nothing&quot; , mf_type : &quot;triangle&quot; , mf_params : [ - 50 , 0 , 50 ] ) he = Flex.Set . new ( tag : &quot;heat&quot; , mf_type : &quot;shoulder&quot; , mf_params : [ 0 , 50 , 100 ] ) Variables Step 2: Define all fuzzy variables with Flex.Variable.new/1 , the following options are required: :tag - (string) Defines the linguistic name of the fuzzy variable (e.g., &quot;error&quot;), :fuzzy_sets - (list) Defines which type of membership function use the set (e.g., &quot;triangle&quot;). :type - (atom) Defines the type of variable (e.g., :antecedent or :consequent), :range - (range) The range in which the variable exists. fuzzy_sets = [ t_h , j_r , t_c ] error = Flex.Variable . new ( tag : &quot;error&quot; , fuzzy_sets : fuzzy_sets , type : :antecedent , range : - 4 .. 4 ) fuzzy_sets = [ g_h , n_c , g_c ] dt_error = Flex.Variable . new ( tag : &quot;dt_error&quot; , fuzzy_sets : fuzzy_sets , type : :antecedent , range : - 10 .. 10 ) fuzzy_sets = [ co , d_n , he ] output = Flex.Variable . new ( tag : &quot;output&quot; , fuzzy_sets : fuzzy_sets , type : :consequent , range : - 100 .. 100 ) Rules Currently there are two types of syntax for defining the rules statement : Anonymous function syntax: r1 = fn [ at1 , at2 , con ] -&gt; ( at1 ~&gt; &quot;too hot&quot; &amp;&amp;&amp; at2 ~&gt; &quot;getting colder&quot; ) &gt;&gt;&gt; con ~&gt; &quot;cool&quot; end Tuple syntax: r1 = { { { { &quot;error&quot; , &quot;too hot&quot; , &quot;~&gt;&quot; } , { &quot;dt_error&quot; , &quot;getting colder&quot; , &quot;~&gt;&quot; } , &quot;&amp;&amp;&amp;&quot; } , &quot;output&quot; , &quot;&gt;&gt;&gt;&quot; } , &quot;cool&quot; , &quot;~&gt;&quot; } Step 3: Define all Linguistic rules with Flex.Rule.new/1 , the following options are required: :statement - Defines the rule behavior. :antecedent - (list) Defines the input variables. :consequent - Defines the output variable. import Flex.Rule r1 = { { { { &quot;error&quot; , &quot;too hot&quot; , &quot;~&gt;&quot; } , { &quot;dt_error&quot; , &quot;getting colder&quot; , &quot;~&gt;&quot; } , &quot;&amp;&amp;&amp;&quot; } , &quot;output&quot; , &quot;&gt;&gt;&gt;&quot; } , &quot;cool&quot; , &quot;~&gt;&quot; } r2 = { { { { &quot;error&quot; , &quot;just right&quot; , &quot;~&gt;&quot; } , { &quot;dt_error&quot; , &quot;getting colder&quot; , &quot;~&gt;&quot; } , &quot;&amp;&amp;&amp;&quot; } , &quot;output&quot; , &quot;&gt;&gt;&gt;&quot; } , &quot;heat&quot; , &quot;~&gt;&quot; } r3 = { { { { &quot;error&quot; , &quot;too cold&quot; , &quot;~&gt;&quot; } , { &quot;dt_error&quot; , &quot;getting colder&quot; , &quot;~&gt;&quot; } , &quot;&amp;&amp;&amp;&quot; } , &quot;output&quot; , &quot;&gt;&gt;&gt;&quot; } , &quot;heat&quot; , &quot;~&gt;&quot; } r4 = { { { { &quot;error&quot; , &quot;too hot&quot; , &quot;~&gt;&quot; } , { &quot;dt_error&quot; , &quot;no change&quot; , &quot;~&gt;&quot; } , &quot;&amp;&amp;&amp;&quot; } , &quot;output&quot; , &quot;&gt;&gt;&gt;&quot; } , &quot;cool&quot; , &quot;~&gt;&quot; } r5 = { { { { &quot;error&quot; , &quot;just right&quot; , &quot;~&gt;&quot; } , { &quot;dt_error&quot; , &quot;no change&quot; , &quot;~&gt;&quot; } , &quot;&amp;&amp;&amp;&quot; } , &quot;output&quot; , &quot;&gt;&gt;&gt;&quot; } , &quot;do nothing&quot; , &quot;~&gt;&quot; } r6 = { { { { &quot;error&quot; , &quot;too cold&quot; , &quot;~&gt;&quot; } , { &quot;dt_error&quot; , &quot;no change&quot; , &quot;~&gt;&quot; } , &quot;&amp;&amp;&amp;&quot; } , &quot;output&quot; , &quot;&gt;&gt;&gt;&quot; } , &quot;heat&quot; , &quot;~&gt;&quot; } r7 = { { { { &quot;error&quot; , &quot;too hot&quot; , &quot;~&gt;&quot; } , { &quot;dt_error&quot; , &quot;getting hotter&quot; , &quot;~&gt;&quot; } , &quot;&amp;&amp;&amp;&quot; } , &quot;output&quot; , &quot;&gt;&gt;&gt;&quot; } , &quot;cool&quot; , &quot;~&gt;&quot; } r8 = { { { { &quot;error&quot; , &quot;just right&quot; , &quot;~&gt;&quot; } , { &quot;dt_error&quot; , &quot;getting hotter&quot; , &quot;~&gt;&quot; } , &quot;&amp;&amp;&amp;&quot; } , &quot;output&quot; , &quot;&gt;&gt;&gt;&quot; } , &quot;cool&quot; , &quot;~&gt;&quot; } r9 = { { { { &quot;error&quot; , &quot;too cold&quot; , &quot;~&gt;&quot; } , { &quot;dt_error&quot; , &quot;getting hotter&quot; , &quot;~&gt;&quot; } , &quot;&amp;&amp;&amp;&quot; } , &quot;output&quot; , &quot;&gt;&gt;&gt;&quot; } , &quot;cool&quot; , &quot;~&gt;&quot; } rule1 = Flex.Rule . new ( statement : r1 , consequent : output . tag , antecedent : [ error . tag , dt_error . tag ] ) rule2 = Flex.Rule . new ( statement : r2 , consequent : output . tag , antecedent : [ error . tag , dt_error . tag ] ) rule3 = Flex.Rule . new ( statement : r3 , consequent : output . tag , antecedent : [ error . tag , dt_error . tag ] ) rule4 = Flex.Rule . new ( statement : r4 , consequent : output . tag , antecedent : [ error . tag , dt_error . tag ] ) rule5 = Flex.Rule . new ( statement : r5 , consequent : output . tag , antecedent : [ error . tag , dt_error . tag ] ) rule6 = Flex.Rule . new ( statement : r6 , consequent : output . tag , antecedent : [ error . tag , dt_error . tag ] ) rule7 = Flex.Rule . new ( statement : r7 , consequent : output . tag , antecedent : [ error . tag , dt_error . tag ] ) rule8 = Flex.Rule . new ( statement : r8 , consequent : output . tag , antecedent : [ error . tag , dt_error . tag ] ) rule9 = Flex.Rule . new ( statement : r9 , consequent : output . tag , antecedent : [ error . tag , dt_error . tag ] ) rules = [ rule1 , rule2 , rule3 , rule4 , rule5 , rule6 , rule7 , rule8 , rule9 ] Note : You need to import Flex.Rule module. System Step 4: Define FLS with Flex.System.start_link/1 or Flex.System.start_link/2 if you want to overwrite the GenServer options; the following options are require: :rules - Defines the behavior of the system based on a list of rules. :antecedent - (list) Defines the input variables. :consequent - Defines the output variable. :engine_type - Defines the inference engine behavior (default: Mamdini). { :ok , s_pid } = Flex.System . start_link ( antecedent : [ error , dt_error ] , consequent : output , rules : rules ) Step 5: Fit the FLS with a input vector using Flex.System.compute/2 . result = Flex.System . compute ( s_pid , [ - 1 , - 2.5 ] ) #result ~= -63.4 aprox In test/system_test.exs there is an example of use, that is based on this example . ANFIS An adaptive network-based fuzzy inference system (ANFIS) is a kind of artificial neural network that is based on Takagi–Sugeno fuzzy inference system, this implementation use backpropagation, only Gaussian &amp; Generalized Bell Membership functions are allowed. In examples/anfis_demo1.exs there is an example of use.","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"The docs can be found at https://hexdocs.pm/flex .","ref":"readme.html#documentation","title":"README - Documentation","type":"extras"},{"doc":"Fork our repository on github. Fix or add what is needed. Commit to your repository. Issue a github pull request (fill the PR template).","ref":"readme.html#contributing","title":"README - Contributing","type":"extras"},{"doc":"See LICENSE .","ref":"readme.html#license","title":"README - License","type":"extras"},{"doc":"Add more membership functions. Add more inference methods. Add more defuzzification methods. Add helper functions. Add metaprogramming for linguistic rules.","ref":"readme.html#todo","title":"README - TODO","type":"extras"}]